/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package listefilms;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

/**
 *
 * @author Vince
 */
public class Frame extends JFrame implements ActionListener {

    private JLabel label = new JLabel("Dossier étudié : ");
    private JLabel dossier = new JLabel("Aucun");
    private JButton generer = new JButton("Générer la liste");
    private JButton copier = new JButton("Copier la liste");
    private JButton choisirRep = new JButton("Choisir un dossier");
    private JButton about = new JButton("A propos...");
    private JButton quitter = new JButton("Quitter");
    private JCheckBox systemFiles = new JCheckBox("Inclure desktop.ini, Thumbs.db");
    private JCheckBox extensions = new JCheckBox("Inclure les extensions", false);
    private JCheckBox sousRep = new JCheckBox("Aller dans les sous-répertoires", true);
    private JTextArea liste = new JTextArea("Choisissez un dossier.");
    private final Clipboard clipboard = getToolkit().getSystemClipboard();
    private final String version = "1.0";

    public Frame() {
        initComponents();

        // Apparence
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (ClassNotFoundException ex) {
        } catch (InstantiationException ex) {
        } catch (IllegalAccessException ex) {
        } catch (UnsupportedLookAndFeelException ex) {
        }
        SwingUtilities.updateComponentTreeUI(this);

        setTitle("vListe "+ version +" , par Vincent Fouache");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setSize(450, 300);
        setVisible(true);
    }

    private void initComponents() {
        generer.addActionListener(this);
        copier.addActionListener(this);
        choisirRep.addActionListener(this);
        about.addActionListener(this);
        quitter.addActionListener(this);

        JPanel haut = new JPanel(new FlowLayout(FlowLayout.LEFT));
        haut.add(label);
        haut.add(dossier);

        JPanel options = new JPanel(new GridLayout(3, 1));
        options.add(sousRep);
        options.add(extensions);
        options.add(systemFiles);
        options.setBorder(BorderFactory.createTitledBorder("Options"));

        JPanel actions = new JPanel(new GridLayout(3, 1));
        actions.add(choisirRep);
        actions.add(generer);
        actions.add(copier);
        actions.setBorder(BorderFactory.createTitledBorder("Actions"));

        JPanel gauche = new JPanel(new GridLayout(2, 1));
        gauche.add(options);
        gauche.add(actions);

        JPanel bas = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        bas.add(about);
        bas.add(quitter);

        this.getContentPane().setLayout(new BorderLayout());
        this.getContentPane().add(haut, BorderLayout.NORTH);
        this.getContentPane().add(gauche, BorderLayout.WEST);
        this.getContentPane().add(new JScrollPane(liste), BorderLayout.CENTER);
        this.getContentPane().add(bas, BorderLayout.SOUTH);
    }

    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == generer) {
            int nbSsRep = sousRep.isSelected() ? 99 : 1;
            VListe vl = new VListe(nbSsRep, extensions.isSelected(), systemFiles.isSelected());
            vl.generer(dossier.getText());
            liste.setText(vl.getvListe());
            JOptionPane.showMessageDialog(this, vl.getNbResultats() + " résultats trouvés.");
        } else if (e.getSource() == copier) {
            StringSelection clipString = new StringSelection(liste.getText());
            clipboard.setContents(clipString, clipString);
        } else if (e.getSource() == quitter) {
            setVisible(false);
            dispose();
            System.exit(0);
        } else if (e.getSource() == about) {
            JOptionPane.showMessageDialog(this, "vListe "+version+"\nPar Vincent Fouache\nDernière version : 11 janvier 2010");
        } else if (e.getSource() == choisirRep) {
            JFileChooser chooser = new JFileChooser();
            chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            int returnVal = chooser.showOpenDialog(this);
            if (returnVal == JFileChooser.APPROVE_OPTION) {
                String newFolder = chooser.getSelectedFile().toString();
                if (newFolder.length() > 65) {
                    // Si le chemin est trop long
                    // on affiche que les 60 derniers caractères.
                    newFolder = "..." + newFolder.substring(newFolder.length() - 60);
                }
                dossier.setText(newFolder);
            }
        }
    }
}
