package listefilms;

import java.io.File;

/**
 *
 * @author Vince
 */
public class VListe {

    // Nombre de sous répertoires parcourus
    private int arborescence = 0;
    // Nombre de sous répertoire à parcourir
    private int arboMax;
    // Nombre de fichiers trouvés
    private int nbResultats = 0;
    // Liste des fichiers
    private String vListe = "";
    // Options
    private boolean extensions;
    private boolean systemFiles;

    public VListe(int arboMax, boolean extensions, boolean systemFiles) {
        this.arboMax = arboMax;
        this.extensions = extensions;
        this.systemFiles = systemFiles;
    }

    public void generer(String dir) {
        File file = new File(dir);
        String list[];

        if (file.isDirectory()) {
            arborescence++;
            if (arborescence <= arboMax) {
                list = file.list();
                for (int i = 0; i < list.length; i++) {
                    generer(dir + File.separatorChar + list[i]);
                }
            }
        } else {
            String nomFichier = file.toString();

            // On l'enlève le chemin
            int posDernierSlash = nomFichier.lastIndexOf("\\");
            if (posDernierSlash != -1) {
                nomFichier = nomFichier.substring(posDernierSlash + 1);
            }

            // Condition pour l'option systemFiles
            if ((!systemFiles && !nomFichier.equals("desktop.ini") && !nomFichier.equals("desktop") && !nomFichier.equals("Thumbs.db"))
                    || systemFiles) {
                // On enlève l'extension ?
                if (!extensions) {
                    int posDernierPoint = nomFichier.lastIndexOf(".");
                    if (posDernierPoint != -1) {
                        nomFichier = nomFichier.substring(0, posDernierPoint);
                    }
                }

                // On ajoute le fichire à la liste
                vListe += nomFichier + "\n";
                nbResultats++;
            }
        }
    }

    public String getvListe() {
        return vListe;
    }

    public int getNbResultats() {
        return nbResultats;
    }
}
